# Class ReaderRowSequence

java.lang.Object
uk.ac.starlink.table.ReaderRowSequence

All Implemented Interfaces:
  `Closeable, AutoCloseable, RowData, RowSequence, uk.ac.starlink.util.Sequence`

public abstract class ReaderRowSequence extends Object implements RowSequence
Partial implementation of `RowSequence` suitable for subclassing by classes which can read a row at a time and don't know when the row stream will come to an end. Concrete subclasses have to implement the `readRow()` method. They may also want to override `close()`.

Author:
  Mark Taylor (Starlink)

## Constructor Summary

Constructors
Constructor
Description
`ReaderRowSequence()`

## Method Summary

Modifier and Type
Method
Description
`void`
`close()`
The `ReaderRowSequence` implementation does nothing.
`Object`
`getCell(int icol)`
Returns the contents of a cell in the current row.
`Object[]`
`getRow()`
Returns the contents of the current table row, as an array with the same number of elements as there are columns in this table.
`boolean`
`next()`
Attempts to advance the current row to the next one.
`protected abstract Object[]`
`readRow()`
Acquires the next row of objects from the input stream.

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ReaderRowSequence

public ReaderRowSequence()

## Method Details

### readRow

protected abstract Object[] readRow() throws IOException
Acquires the next row of objects from the input stream. When there are no more rows to read this method must return `null`; note it should not throw an exception to indicate this fact. Otherwise it must return an array of objects representing the row content for the next row.

Returns:
  the next row, or `null` if there are no more
Throws:
  `IOException` - if there is trouble reading the data

### next

public boolean next() throws IOException
Description copied from interface: `RowSequence`
Attempts to advance the current row to the next one. If `true` is returned the attempt has been successful, and if `false` is returned there are no more rows in this sequence. Since the initial position of a RowSequence is before the first row, this method must be called before current row data can be accessed using the `RowSequence.getCell(int)` or `RowSequence.getRow()` methods.

Specified by:
  `next` in interface `RowSequence`
Specified by:
  `next` in interface `uk.ac.starlink.util.Sequence`
Returns:
  `true` iff this sequence has been advanced to the next row
Throws:
  `IOException` - if there is some error

### getCell

public Object getCell(int icol)
Description copied from interface: `RowSequence`
Returns the contents of a cell in the current row. The class of the returned object should be the same as, or a subclass of, the class returned by `getColumnInfo(icol).getContentClass()`. An unchecked exception will be thrown if there is no current row (`next` has not yet been called).

Specified by:
  `getCell` in interface `RowData`
Specified by:
  `getCell` in interface `RowSequence`
Parameters:
  `icol` - column index
Returns:
  the contents of cell `icol` in the current row

### getRow

public Object[] getRow()
Description copied from interface: `RowSequence`
Returns the contents of the current table row, as an array with the same number of elements as there are columns in this table. An unchecked exception will be thrown if there is no current row (`next` has not yet been called).

Specified by:
  `getRow` in interface `RowData`
Specified by:
  `getRow` in interface `RowSequence`
Returns:
  an array of the objects in each cell in row `irow`

### close

public void close() throws IOException
The `ReaderRowSequence` implementation does nothing.

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `Closeable`
Specified by:
  `close` in interface `RowSequence`
Throws:
  `IOException`